


//int custom_0[] = { 0x15, 0x1a, 0x15, 0x1a, 0x15, 0x10, 0x10, 0x10}; // checked flag 
int custom_0[] = { 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02}; // |


/*
   _
   _|
*/
int custom_1[] = { 0x1e, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x1e}; 


/*
|_|
*/
int custom_2[] = { 0x12, 0x12, 0x12, 0x12, 0x12, 0x12, 0x12, 0x1e};


/*
 _
|_
*/
int custom_3[] = { 0x1e, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x1e};


/*
|_
*/
int custom_4[] = { 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x1e};


/*
 _
  |
*/
int custom_5[] = { 0x1e, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02};


/*
 _
|_|
*/
int custom_6[] = { 0x1e, 0x12, 0x12, 0x12, 0x12, 0x12, 0x12, 0x1e};


/*
 _
| |
*/
int custom_7[] = { 0x1e, 0x12, 0x12, 0x12, 0x12, 0x12, 0x12, 0x12};




void lcdSetup() {
  
  lcd.begin(9600);
  
  delay(200);
  lcd.print(124, BYTE);
  lcd.print(157, BYTE);
  //delay(500);
  
  lcd.print(0xfe, BYTE);
  lcd.print(0x01, BYTE);
  delay(200);
  
  lcd.print(0xfe, BYTE);
  lcd.print(0x0c, BYTE);
  //rfSerial.print(0xfe, BYTE);
  //rfSerial.print(0x81, BYTE);
  
  delay(200);
  defineCharacter(0, custom_0);
  delay(200);
  defineCharacter(1, custom_1);
  delay(200);
  defineCharacter(2, custom_2);
  delay(200);
  defineCharacter(3, custom_3);
  delay(200);
  defineCharacter(4, custom_4);
  delay(200);
  defineCharacter(5, custom_5);
  delay(200);
  defineCharacter(6, custom_6);
  delay(200);
  defineCharacter(7, custom_7);
  
  delay(200);
}
// mode is 0 for clock, 1 for clock setting and 2 for alarm time setting
void printTime(int h, int m, int mode) {
  int index = 0;
  boolean isAm = true;
  
  if (h > 11) {
    h = h - 12;
    isAm = false;
  } 
  if (h < 1) {
    h = 12;
  }
  
  if (h < 10) {
    clearSpace(index);
    index += 1;
    printNum(h, index);
  } else {
    //Serial.print("This is the h: ");
    //Serial.println(h);
    int rDigit = h % 10;
    int lDigit = (h - rDigit)/10;
    printNum(lDigit, index);
    index += 1;
    printNum(rDigit, index);
  }
  index += 1;
  
  printColon(index);
  
  index += 1;
  
  if (m < 10) {
    printNum(0, index);
    index += 1;
    printNum(m, index);
  } else {
    int rDigit = m % 10;
    int lDigit = (m - rDigit)/10;
    printNum(lDigit, index);
    index += 1;
    printNum(rDigit, index);
  }
  
  printAmPm(isAm, 64 + 7);
  showSettingTime(mode, 7);
  
}

void printNum(int num, int index) {
  int top = 0;
  int bot = 0;
  
  switch (num) {
    case 0:
      top = 7;
      bot = 2;
      break;
      
    case 1:
      top = 0;
      bot = 0;
      break;
    
    case 2:
      top = 1;
      bot = 4;
      break;
      
    case 3:
      top = 1;
      bot = 1;
      break;
      
    case 4:
      top = 2;
      bot = 0;
      break;
      
    case 5:
      top = 3;
      bot = 1;
      break;
      
    case 6:
      top = 4;
      bot = 2;
      break;
      
    case 7:
      top = 5;
      bot = 0;
      break;
      
    case 8:
      top = 6;
      bot = 6;
      break;
      
    case 9:
      top = 6;
      bot = 0;
      break;
      
  }
  lcd.print(0xfe, BYTE);
  lcd.print(0x80 + index, BYTE);
  lcd.print(top, BYTE);
  lcd.print(0xfe, BYTE);
  lcd.print(0x80 + 64 + index, BYTE);
  lcd.print(bot, BYTE);
}

void printColon(int index) {
  lcd.print(0xfe, BYTE);
  lcd.print(0x80 + index, BYTE);
  lcd.print(0xa5, BYTE);
  lcd.print(0xfe, BYTE);
  lcd.print(0x80 + 64 + index, BYTE);
  lcd.print(0xa5, BYTE);
}

void clearSpace(int index) {
  lcd.print(0xfe, BYTE);
  lcd.print(0x80 + index, BYTE);
  lcd.print(" ");
  lcd.print(0xfe, BYTE);
  lcd.print(0x80 + 64 + index, BYTE);
  lcd.print(" ");
}

void printAmPm(boolean isAm, int index) {
  lcd.print(0xfe, BYTE);
  lcd.print(0x80 + index, BYTE);
  if (isAm)
    lcd.print("AM");
  else 
    lcd.print("PM");
}

void showSettingTime(int mode, int index) {
  lcd.print(0xfe, BYTE);
  lcd.print(0x80 + index, BYTE);
  if (mode == 1)
    lcd.print("CLOCK");
  else if (mode == 2)
    lcd.print("ALARM");
  else 
    lcd.print("     ");
}

// print out the alarm char, to be called from the main funcs
void printAlarmSymbol(boolean isOn) {
  if (isOn) {
    lcd.print(0xfe, BYTE);
    lcd.print(0x80 + 13, BYTE);
    lcd.print("x");
    lcd.print("x");
  
    lcd.print(0xfe, BYTE);
    lcd.print(0x80 + 13 + 64, BYTE);
    lcd.print(0xdb, BYTE);
    lcd.print(0xdb, BYTE);
  } else {
    lcd.print(0xfe, BYTE);
    lcd.print(0x80 + 13, BYTE);
    lcd.print(" ");
    lcd.print(" ");
  
    lcd.print(0xfe, BYTE);
    lcd.print(0x80 + 13 + 64, BYTE);
    lcd.print(" ");
    lcd.print(" ");
    lcd.print(" ");
  }
}

// Define a custom char in lcd
// http://www.arduino.cc/cgi-bin/yabb2/YaBB.pl?num=1235524565/0
int defineCharacter(int ascii, int *data) {
    int baseAddress = (ascii * 8) + 64;  
    // baseAddress = 64 | (ascii << 3);
    lcd.print(0xfe, BYTE);
    lcd.print(baseAddress, BYTE);
    for (int i = 0; i < 8; i++)
        lcd.print(data[i], BYTE);
    lcd.print(0xfe, BYTE);
    lcd.print(128, BYTE);
    return ascii;
} 



